\Wormhole.xpl
\Based on Worm.asm (22-Oct-1993) in Fake Demo by Pelusa (aka: Carlos Hasan)

include c:\cxpl\codesi;

int	Fade;			\color intensity (0..128)
char	Palette(3*256);		\copy of color registers


proc	VSync;			\Wait for vertical retrace to begin
begin
while PIn($3DA,0) & $08 do [];	\wait for vertical retrace signal to go away
repeat until PIn($3DA,0) & $08;	\wait for vertical retrace
end;	\VSync


proc	Rotate;			\Rotate Palette and adjust Fade intensity
int	I, J, K,		\indexes
	R, G, B;		\red, green, blue
begin
for I:= 0, 240*3-1 do		\shift down 16*3 bytes
	Palette(I):= Palette(I+16*3);
for I:= 0, 16*3-1 do		\wrap 16*3 bytes to the end
	Palette(I+240*3):= Palette(I);
K:= 0;				\rotate 16*3 bytes in each of 16 groups
for I:= 0, 16-1 do
	begin
	R:= Palette(K);
	G:= Palette(K+1);
	B:= Palette(K+2);
	for J:= 0, 15*3-1 do
		begin
		Palette(K):= Palette(K+3);
		K:= K+1;
		end;
	Palette(K):= R;
	Palette(K+1):= G;
	Palette(K+2):= B;
	K:= K+3;
	end;
VSync;				\regulate speed
POut(16, $3C8, 0);		\copy Palette to color registers
for I:= 16*3, 256*3-1 do	\ but don't alter the border color (0)
	POut(Palette(I)*Fade/128, $3C9, 0);
end;	\Rotate


proc	LoadBmp(Name);		\Load a 320x200x8 .bmp file but don't display it
char	Name;			\file name
int	Hand, I, T,
	X, Y;			\coordinates
begin
Hand:= FOpen(Name, 0);			\open file for input
FSet(Hand, ^I);				\set device 3 to handle
OpenI(3);

for I:= 0, 53 do T:= ChIn(3);		\skip unused header info

for I:= 0, 255 do
	begin
	Palette(I*3+2):= ChIn(3)>>2;	\blue
	Palette(I*3+1):= ChIn(3)>>2;	\green
	Palette(I*3+0):= ChIn(3)>>2;	\red
	T:= ChIn(3);			\unused
	end;

for Y:= -(200-1), 0 do			\.bmp files are upside down!
    for X:= 0, 320-1 do
	Point(X, -Y, ChIn(3));

FClose(Hand);
end;	\LoadBmp


begin	\Main
SetVid($13);				\320x200x8-bit color
Fade:= 0;				\set all color registers to black
Rotate;
LoadBmp("WORMHOLE.BMP");

repeat	if Fade < 128 then Fade:= Fade+1; \fade in
	Rotate;
until	ChkKey;				\loop until keystroke

repeat	Fade:= Fade-1;			\fade out
	Rotate;
until	Fade <= 0;

SetVid($03);				\restore normal text mode
end;	\Main
